MainApplication/Controllers/LessonController.cs
using Domain.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using RestSharp;
using MainApplication.token;

namespace MainApplication.Controllers
{
    public class LessonController : Controller
    {

        // GET: Lesson
        [HttpGet]
        public ActionResult Index()
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.tenantid = token.getTenantFromToken().Id;

            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            var clientrest = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
            var requestrest = new RestRequest("lesson", Method.GET);
            requestrest.AddHeader("content-type", "application/json");
            requestrest.AddHeader("Authorization", "Bearer " + Session["token"]);
            requestrest.ToString();
            var response1 = clientrest.Execute<List<Lesson>>(requestrest);

            return View(response1.Data);
         
        }

        // GET: Lesson/Details/5
        [HttpGet]
        public ActionResult Details(int id)
        {

            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.tenantid = token.getTenantFromToken().Id;

            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            var clientrest = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
            var requestrest = new RestRequest("lesson/"+id, Method.GET);
            requestrest.AddHeader("Authorization", "Bearer " + Session["token"]);
            requestrest.AddHeader("content-type", "application/json");

            requestrest.ToString();
            var response1 = clientrest.Execute<Lesson>(requestrest);
            return View(response1.Data);
        }

        // GET: Lesson/Create
        public ActionResult Create()
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.tenantid = token.getTenantFromToken().Id;

            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            return View();
        }

        // POST: Lesson/Create
        [HttpPost]
        public ActionResult Create(Lesson less)
        {
            try
            {

                if (Session["token"] == null)
                {
                    TempData["err_auth_msg"] = "you are not authenticated to access that page";
                    return RedirectToAction("index", "Auth");
                }

                JWToken token = new JWToken() { Token = Session["token"].ToString() };
                ViewBag.tenantname = token.getTenantFromToken().Name;
                ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
                ViewBag.tenantid = token.getTenantFromToken().Id;

                ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
                ViewBag.username = token.getUserFromToken().username;
                ViewBag.userid = token.getUserFromToken().Id;
                var client = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
                var request = new RestRequest("lesson", Method.POST);
                request.AddHeader("Authorization", "Bearer " + Session["token"]);
                request.RequestFormat = DataFormat.Json;

                request.AddBody(new Lesson
                {
                    Titre = less.Titre,
                    URIImage = less.URIImage,
                    URIVideo = less.URIVideo,
                    
                }
                    );
                client.Execute<Lesson>(request);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Lesson/Edit/5
        public ActionResult Edit(int id)
        {

            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.tenantid = token.getTenantFromToken().Id;

            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            var clientrest = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
                var requestrest = new RestRequest("lesson/" + id, Method.GET);
            requestrest.AddHeader("Authorization", "Bearer " + Session["token"]);
            requestrest.AddHeader("content-type", "application/json");
                requestrest.ToString();
                var response1 = clientrest.Execute<Lesson>(requestrest);
                return View(response1.Data);
                
        }

        // POST: Lesson/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, Lesson less)
        {
            try
            {

                if (Session["token"] == null)
                {
                    TempData["err_auth_msg"] = "you are not authenticated to access that page";
                    return RedirectToAction("index", "Auth");
                }

                JWToken token = new JWToken() { Token = Session["token"].ToString() };
                ViewBag.tenantname = token.getTenantFromToken().Name;
                ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
                ViewBag.tenantid = token.getTenantFromToken().Id;

                ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
                ViewBag.username = token.getUserFromToken().username;
                ViewBag.userid = token.getUserFromToken().Id;
                var client = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
                var request = new RestRequest("Lesson/"+id, Method.PUT);
                request.AddHeader("Authorization", "Bearer " + Session["token"]);

                request.RequestFormat = DataFormat.Json;
                request.AddBody(new Lesson
                {
                    Id = id,
                    Titre = less.Titre,
                    URIImage = less.URIImage,
                    URIVideo = less.URIVideo

                });

                var response = client.Execute<Lesson>(request);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Lesson/Delete/5
        public ActionResult Delete(int id)
        {

            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.tenantid = token.getTenantFromToken().Id;

            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            var clientrest = new RestClient("http://pi-net-servicepattern-dev.eu-west-1.elasticbeanstalk.com/api/");
            var requestrest = new RestRequest("lesson/" + id, Method.GET);
            requestrest.AddHeader("content-type", "application/json");
            requestrest.AddHeader("Authorization", "Bearer " + Session["token"]);
            requestrest.ToString();
            var response1 = clientrest.Execute<Lesson>(requestrest);
            return View(response1.Data);
        }

        // POST: Lesson/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {

                if (Session["token"] == null)
                {

MainApplication/Views/Lesson/Create.cshtml
@model Domain.Entities.Lesson

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}



@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

<div class="container-fluid">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="instructor-dashboard.html">Home</a></li>
        <li class="breadcrumb-item active">Courses</li>
    </ol>
    <div class="media align-items-center">
        <h1 class="page-heading h2">Add Lesson</h1>  
    </div>
    <div class="card card-box">
        <div class="card-body">
            <form action="#">
                <div class="form-group row">
                    <label for="avatar" class="col-sm-3 form-control-label">Preview</label>
                    <div class="col-sm-9">
                        <div class="media">
                            <div class="media-left">
                                <img src="assets/images/cour.png" alt="" width="100" class="rounded">
                            </div>
                            <div class="media-body media-middle">
                                <label class="custom-file m-0">
                                    <input type="file" id="file">
                                    <span class="custom-file-control"></span>
                                </label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.Titre, htmlAttributes: new { @class = "form-control-label col-md-3" })
             
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.Titre, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.Titre, "", new { @class = "text-danger" })
                  
                      
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.URIImage, htmlAttributes: new { @class = "form-control-label col-md-3" })
            
                    <div class="col-md-9">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    @Html.EditorFor(model => model.URIImage, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.URIImage, "", new { @class = "text-danger" })
                            
                                    <small class="help-block text-muted-light"><i class="material-icons md-18">ondemand_video</i> <span class="icon-text">Paste Image </span></small>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.URIVideo, htmlAttributes: new { @class = "form-control-label col-md-3" })
                   
                    <div class="col-md-9">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    
                                    @Html.EditorFor(model => model.URIVideo, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.URIVideo, "", new { @class = "text-danger" })
                    
                                    <small class="help-block text-muted-light"><i class="material-icons md-18">ondemand_video</i> <span class="icon-text">Paste Video</span></small>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <div class="embed-responsive embed-responsive-16by9">
                                        <iframe class="embed-responsive-item" src="https://vimeo.com/channels/staffpicks/215880646?title=0&amp;byline=0&amp;portrait=0" allowfullscreen=""></iframe>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <div class="offset-md-3 col-md-9">
                        <input type="submit" value="Create" class="btn btn-success" />
                        <a href="@Url.Action("/Index", "Lesson" )" class="btn btn-default">Cancel</a>
                    </div>
                </div>
            </form>
        </div>
        
    </div>
</div>

}

<div>
   
</div>

MainApplication/Views/Lesson/Delete.cshtml
@model Domain.Entities.Lesson

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link rel="stylesheet" href="~/Content/sweetalert.css">
<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Lesson</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Titre)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Titre)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.URIImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.URIImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.URIVideo)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.URIVideo)
        </dd>

    </dl>

    <div class="sweet-overlay" tabindex="-1" style="opacity: 1.12; display: block;"></div><div class="sweet-alert showSweetAlert visible" data-custom-class="" data-has-cancel-button="true" data-has-confirm-button="true" data-allow-outside-click="false" data-has-done-function="true" data-animation="pop" data-timer="null" style="display: block; margin-top: -170px;">
        <div class="sa-icon sa-error" style="display: none;">
            <span class="sa-x-mark">
                <span class="sa-line sa-left"></span>
                <span class="sa-line sa-right"></span>
            </span>
        </div><div class="sa-icon sa-warning pulseWarning" style="display: block;">
            <span class="sa-body pulseWarningIns"></span>
            <span class="sa-dot pulseWarningIns"></span>
        </div><div class="sa-icon sa-info" style="display: none;"></div><div class="sa-icon sa-success" style="display: none;">
            <span class="sa-line sa-tip"></span>
            <span class="sa-line sa-long"></span>

            <div class="sa-placeholder"></div>
            <div class="sa-fix"></div>
        </div><div class="sa-icon sa-custom" style="display: none;"></div><h2>Are you sure?</h2>
        <p style="display: block;">You will not be able to recover this imaginary file!</p>
        <fieldset>
            <input tabindex="3" placeholder="" type="text">
            <div class="sa-input-error"></div>
        </fieldset><div class="sa-error-container">
            <div class="icon">!</div>
            <p>Not valid!</p>
        </div>
@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    <div class="sa-button-container">
        <button onclick="location.href='@Url.Action("Index/", "Lesson")';return false;" class="cancel" tabindex="2" style="display: inline-block; box-shadow: none;">No, cancel plx!</button>
           
            <div class="sa-confirm-button-container">
                <button class="confirm" type="submit" tabindex="1" style="display: inline-block; background-color: rgb(3, 155, 229); box-shadow: rgba(3, 155, 229, 0.8) 0px 0px 2px, rgba(0, 0, 0, 0.05) 0px 0px 0px 1px inset;">Yes, delete it!</button><div class="la-ball-fall">
                    <div></div>
                    <div></div>
                    <div></div>
                </div>
            </div>
        </div>
}
    </div>


    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>
<script src="~/Scripts/sweetalert.js"></script>

MainApplication/Views/Lesson/Details.cshtml
@model Domain.Entities.Lesson


@{
    ViewBag.Title = "Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Details</h2>

<div>
    <h4>Lesson</h4>
    <hr />


    
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Titre)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Titre)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.URIImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.URIImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.URIVideo)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.URIVideo)
        </dd>

    </dl>
</div>


<p>
    
    @Html.ActionLink("Back to List", "Index")
</p>

MainApplication/Views/Lesson/Edit.cshtml
@model Domain.Entities.Lesson

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
@Html.ValidationSummary(true, "", new { @class = "text-danger" })
@Html.HiddenFor(model => model.Id)
<div class="container-fluid">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="instructor-dashboard.html">Home</a></li>
        <li class="breadcrumb-item active">Courses</li>
    </ol>
    <div class="media align-items-center">
        <h1 class="page-heading h2">Edit Lesson</h1>
    </div>
    <div class="card">
        <div class="card-body">            
                <div class="form-group row">
                    <label for="avatar" class="col-sm-3 form-control-label">Preview</label>
                    <div class="col-sm-9">
                        <div class="media">
                            <div class="media-left">
                                <img src="assets/images/cour.png" alt="" width="100" class="rounded">
                            </div>
                            <div class="media-body media-middle">
                                <label class="custom-file m-0">
                                    <input type="file" id="file">
                                    <span class="custom-file-control"></span>
                                </label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.Titre, htmlAttributes: new { @class = "form-control-label col-md-3" })
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.Titre, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.Titre, "", new { @class = "text-danger" })
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.URIImage, htmlAttributes: new { @class = "form-control-label col-md-3" })
                    <div class="col-md-9">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    @Html.EditorFor(model => model.URIImage, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.URIImage, "", new { @class = "text-danger" })
                                    <small class="help-block text-muted-light"><i class="material-icons md-18">ondemand_video</i> <span class="icon-text">Paste Image </span></small>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    @Html.LabelFor(model => model.URIVideo, htmlAttributes: new { @class = "form-control-label col-md-3" })
                    <div class="col-md-9">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    @Html.EditorFor(model => model.URIVideo, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.URIVideo, "", new { @class = "text-danger" })
                                    <small class="help-block text-muted-light"><i class="material-icons md-18">ondemand_video</i> <span class="icon-text">Paste Video</span></small>
                                </div>
                            </div>                          
                        </div>
                    </div>
                </div>  
            <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-success"/>
                <a href="@Url.Action("/Index", "Lesson" )" class="btn btn-default">Cancel</a>
            </div>
        </div>         
        </div>        
    </div>
</div>
}
<div>
   
</div>

MainApplication/Views/Lesson/Index.cshtml
@model IEnumerable<Domain.Entities.Lesson>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}



<div class="container-fluid">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="instructor-dashboard.html">Home</a></li>
        <li class="breadcrumb-item active">Courses</li>
    </ol>   
    <div class="media align-items-center">
        <div class="media-body">
            <h1 class="page-heading h2">Manage Courses</h1>
            <div class="col-sm-6">
                <form class="navbar-search-form d-none d-md-flex" method="get" action="@Url.Action("Index","Lesson")">
                    <input type="text" class="form-control input-sm" id="titre" placeholder="Search">
                    <button class="btn" type="submit"><i class="material-icons">search</i></button>
                </form>
            </div>
        </div>       
        <div class="media-right">
            @Html.ActionLink("+ New Course", "Create", "Lesson", new { @class = "btn btn-success" })                
        </div>
    </div>
        <div class="card-columns">
            @foreach (var item in Model)
            {
                <div class="card">
                    <div class="card-header bg-white">
                        <div class="media">
                            <div class="media-left media-middle">
                                <a href="@Url.Action("Details", "Lesson" , new { id = item.Id })">
                                    <img src="~/Content/images/NET.png" alt="Card image cap" width="100" class="rounded">
                                </a>
                            </div>
                            <div class="media-body media-middle">
                                <h4 class="card-title"><a href="@Url.Action("Details", "Lesson" , new { id = item.Id })">@Html.DisplayFor(modelItem => item.Titre)</a></h4>
                                <span class="badge badge-primary "></span> <span class="badge badge-light "></span>
                            </div>
                            <div class="media-right media-middle">
                                
                                <a href="@Url.Action("Edit", "Lesson" , new { id = item.Id })" class="btn btn-sm btn-primary"><i class="material-icons btn__icon--left">edit</i>Edit</a>

                                
                                <a href="@Url.Action("Delete", "Lesson" , new { id = item.Id })" class="btn btn-sm btn-primary"><i class="material-icons btn__icon--left">delete</i>Delete</a>
                                

                               
                                                         
                            </div>
                        </div>
                    </div>
                </div>
            }            
        </div>
        <nav class="text-center">
            <ul class="pagination pagination-sm">
                <li class="page-item disabled">
                    <a class="page-link" href="#" aria-label="Previous">
                        <span aria-hidden="true">&laquo;</span>
                        <span class="sr-only">Previous</span>
                    </a>
                </li>
                <li class="page-item active">
                    <a class="page-link" href="#">1 <span class="sr-only">(current)</span></a>
                </li>
                <li class="page-item"><a class="page-link" href="#">2</a></li>
                <li class="page-item"><a class="page-link" href="#">3</a></li>
                <li class="page-item"><a class="page-link" href="#">4</a></li>
                <li class="page-item"><a class="page-link" href="#">5</a></li>
                <li class="page-item">
                    <a class="page-link" href="#" aria-label="Next">
                        <span aria-hidden="true">&raquo;</span>
                        <span class="sr-only">Next</span>
                    </a>
                </li>
            </ul>
        </nav>
    </div>